//>>built
define("dijit/Editor",["require","dojo/_base/array","dojo/_base/declare","dojo/Deferred","dojo/i18n","dojo/dom-attr","dojo/dom-class","dojo/dom-geometry","dojo/dom-style","dojo/keys","dojo/_base/lang","dojo/sniff","dojo/string","dojo/topic","./_Container","./Toolbar","./ToolbarSeparator","./layout/_LayoutWidget","./form/ToggleButton","./_editor/_Plugin","./_editor/plugins/EnterKeyHandling","./_editor/html","./_editor/range","./_editor/RichText","./main","dojo/i18n!./_editor/nls/commands"],function(e,a,t,r,i,d,o,l,n,m,s,f,u,y,M,v,h,c,g,p,b,w,F,k,I){function E(e){return new p({command:e.name})}function G(e){return new p({buttonClass:g,command:e.name})}var j=t("dijit.Editor",k,{plugins:null,extraPlugins:null,constructor:function(){s.isArray(this.plugins)||(this.plugins=["undo","redo","|","cut","copy","paste","|","bold","italic","underline","strikethrough","|","insertOrderedList","insertUnorderedList","indent","outdent","|","justifyLeft","justifyRight","justifyCenter","justifyFull",b]),this._plugins=[],this._editInterval=1e3*this.editActionInterval,(f("ie")||f("trident")||f("edge"))&&(this.events.push("onBeforeDeactivate"),this.events.push("onBeforeActivate"))},postMixInProperties:function(){this.setValueDeferred=new r,this.inherited(arguments)},postCreate:function(){this.inherited(arguments),this._steps=this._steps.slice(0),this._undoedSteps=this._undoedSteps.slice(0),s.isArray(this.extraPlugins)&&(this.plugins=this.plugins.concat(this.extraPlugins)),this.commands=i.getLocalization("dijit._editor","commands",this.lang),f("webkit")&&n.set(this.domNode,"KhtmlUserSelect","none")},startup:function(){this.inherited(arguments),this.toolbar||(this.toolbar=new v({ownerDocument:this.ownerDocument,dir:this.dir,lang:this.lang,"aria-label":this.id}),this.header.appendChild(this.toolbar.domNode)),a.forEach(this.plugins,this.addPlugin,this),this.setValueDeferred.resolve(!0),o.add(this.iframe.parentNode,"dijitEditorIFrameContainer"),o.add(this.iframe,"dijitEditorIFrame"),d.set(this.iframe,"allowTransparency",!0),this.toolbar.startup(),this.onNormalizedDisplayChanged()},destroy:function(){a.forEach(this._plugins,function(e){e&&e.destroy&&e.destroy()}),this._plugins=[],this.toolbar.destroyRecursive(),delete this.toolbar,this.inherited(arguments)},addPlugin:function(a,t){var r=s.isString(a)?{name:a}:s.isFunction(a)?{ctor:a}:a;if(!r.setEditor){var i={args:r,plugin:null,editor:this};if(r.name&&(p.registry[r.name]?i.plugin=p.registry[r.name](r):y.publish(I._scopeName+".Editor.getPlugin",i)),!i.plugin)try{var d=r.ctor||s.getObject(r.name)||e(r.name);d&&(i.plugin=new d(r))}catch(o){throw new Error(this.id+": cannot find plugin ["+r.name+"]")}if(!i.plugin)throw new Error(this.id+": cannot find plugin ["+r.name+"]");a=i.plugin}arguments.length>1?this._plugins[t]=a:this._plugins.push(a),a.setEditor(this),s.isFunction(a.setToolbar)&&a.setToolbar(this.toolbar)},resize:function(e){e&&c.prototype.resize.apply(this,arguments)},layout:function(){var e=this._contentBox.h-(this.getHeaderHeight()+this.getFooterHeight()+l.getPadBorderExtents(this.iframe.parentNode).h+l.getMarginExtents(this.iframe.parentNode).h);this.editingArea.style.height=e+"px",this.iframe&&(this.iframe.style.height="100%"),this._layoutMode=!0},_onIEMouseDown:function(e){var a,t=this.document.body,r=t.clientWidth,i=t.clientHeight,d=t.clientLeft,o=t.offsetWidth,l=t.offsetHeight,n=t.offsetLeft;/^rtl$/i.test(t.dir||"")?o>r&&e.x>r&&e.x<o&&(a=!0):e.x<d&&e.x>n&&(a=!0),a||l>i&&e.y>i&&e.y<l&&(a=!0),a||(delete this._cursorToStart,delete this._savedSelection,"BODY"==e.target.tagName&&this.defer("placeCursorAtEnd"),this.inherited(arguments))},onBeforeActivate:function(){this._restoreSelection()},onBeforeDeactivate:function(e){this.customUndo&&this.endEditing(!0),"BODY"!=e.target.tagName&&this._saveSelection()},customUndo:!0,editActionInterval:3,beginEditing:function(e){this._inEditing||(this._inEditing=!0,this._beginEditing(e)),this.editActionInterval>0&&(this._editTimer&&this._editTimer.remove(),this._editTimer=this.defer("endEditing",this._editInterval))},_steps:[],_undoedSteps:[],execCommand:function(e){if(!this.customUndo||"undo"!=e&&"redo"!=e){this.customUndo&&(this.endEditing(),this._beginEditing());var a=this.inherited(arguments);return this.customUndo&&this._endEditing(),a}return this[e]()},_pasteImpl:function(){return this._clipboardCommand("paste")},_cutImpl:function(){return this._clipboardCommand("cut")},_copyImpl:function(){return this._clipboardCommand("copy")},_clipboardCommand:function(e){var a;try{if(a=this.document.execCommand(e,!1,null),f("webkit")&&!a)throw{}}catch(t){var r=u.substitute,i={cut:"X",copy:"C",paste:"V"};alert(r(this.commands.systemShortcut,[this.commands[e],r(this.commands[f("mac")?"appleKey":"ctrlKey"],[i[e]])])),a=!1}return a},queryCommandEnabled:function(e){return!this.customUndo||"undo"!=e&&"redo"!=e?this.inherited(arguments):"undo"==e?this._steps.length>1:this._undoedSteps.length>0},_moveToBookmark:function(e){var t,r,i,d,o=e.mark,l=e.mark,n=e.isCollapsed;l&&(f("ie")<9||9===f("ie")&&f("quirks")?s.isArray(l)?(o=[],a.forEach(l,function(e){o.push(F.getNode(e,this.editNode))},this),this.selection.moveToBookmark({mark:o,isCollapsed:n})):l.startContainer&&l.endContainer&&(d=F.getSelection(this.window),d&&d.removeAllRanges&&(d.removeAllRanges(),t=F.create(this.window),r=F.getNode(l.startContainer,this.editNode),i=F.getNode(l.endContainer,this.editNode),r&&i&&(t.setStart(r,l.startOffset),t.setEnd(i,l.endOffset),d.addRange(t)))):(d=F.getSelection(this.window),d&&d.removeAllRanges&&(d.removeAllRanges(),t=F.create(this.window),r=F.getNode(l.startContainer,this.editNode),i=F.getNode(l.endContainer,this.editNode),r&&i&&(t.setStart(r,l.startOffset),t.setEnd(i,l.endOffset),d.addRange(t)))))},_changeToStep:function(e,a){this.setValue(a.text);var t=a.bookmark;t&&this._moveToBookmark(t)},undo:function(){var e=!1;if(!this._undoRedoActive){this._undoRedoActive=!0,this.endEditing(!0);var a=this._steps.pop();a&&this._steps.length>0&&(this.focus(),this._changeToStep(a,this._steps[this._steps.length-1]),this._undoedSteps.push(a),this.onDisplayChanged(),delete this._undoRedoActive,e=!0),delete this._undoRedoActive}return e},redo:function(){var e=!1;if(!this._undoRedoActive){this._undoRedoActive=!0,this.endEditing(!0);var a=this._undoedSteps.pop();a&&this._steps.length>0&&(this.focus(),this._changeToStep(this._steps[this._steps.length-1],a),this._steps.push(a),this.onDisplayChanged(),e=!0),delete this._undoRedoActive}return e},endEditing:function(e){this._editTimer&&(this._editTimer=this._editTimer.remove()),this._inEditing&&(this._endEditing(e),this._inEditing=!1)},_getBookmark:function(){var e=this.selection.getBookmark(),t=[];if(e&&e.mark){var r=e.mark;if(f("ie")<9||9===f("ie")&&f("quirks")){var i=F.getSelection(this.window);if(s.isArray(r))a.forEach(e.mark,function(e){t.push(F.getIndex(e,this.editNode).o)},this),e.mark=t;else if(i){var d;i.rangeCount&&(d=i.getRangeAt(0)),e.mark=d?d.cloneRange():this.selection.getBookmark()}}try{e.mark&&e.mark.startContainer&&(t=F.getIndex(e.mark.startContainer,this.editNode).o,e.mark={startContainer:t,startOffset:e.mark.startOffset,endContainer:e.mark.endContainer===e.mark.startContainer?t:F.getIndex(e.mark.endContainer,this.editNode).o,endOffset:e.mark.endOffset})}catch(o){e.mark=null}}return e},_beginEditing:function(){0===this._steps.length&&this._steps.push({text:w.getChildrenHtml(this.editNode),bookmark:this._getBookmark()})},_endEditing:function(){var e=w.getChildrenHtml(this.editNode);this._undoedSteps=[],this._steps.push({text:e,bookmark:this._getBookmark()})},onKeyDown:function(e){if(f("ie")||this.iframe||e.keyCode!=m.TAB||this.tabIndent||this._saveSelection(),!this.customUndo)return void this.inherited(arguments);var a=e.keyCode;if(e.ctrlKey&&!e.shiftKey&&!e.altKey){if(90==a||122==a)return e.stopPropagation(),e.preventDefault(),void this.undo();if(89==a||121==a)return e.stopPropagation(),e.preventDefault(),void this.redo()}switch(this.inherited(arguments),a){case m.ENTER:case m.BACKSPACE:case m.DELETE:this.beginEditing();break;case 88:case 86:if(e.ctrlKey&&!e.altKey&&!e.metaKey){this.endEditing(),this.beginEditing(88==e.keyCode?"cut":"paste"),this.defer("endEditing",1);break}default:if(!e.ctrlKey&&!e.altKey&&!e.metaKey&&(e.keyCode<m.F1||e.keyCode>m.F15)){this.beginEditing();break}case m.ALT:this.endEditing();break;case m.UP_ARROW:case m.DOWN_ARROW:case m.LEFT_ARROW:case m.RIGHT_ARROW:case m.HOME:case m.END:case m.PAGE_UP:case m.PAGE_DOWN:this.endEditing(!0);break;case m.CTRL:case m.SHIFT:case m.TAB:}},_onBlur:function(){this.inherited(arguments),this.endEditing(!0)},_saveSelection:function(){try{this._savedSelection=this._getBookmark()}catch(e){}},_restoreSelection:function(){this._savedSelection&&(delete this._cursorToStart,this.selection.isCollapsed()&&this._moveToBookmark(this._savedSelection),delete this._savedSelection)},onClick:function(){this.endEditing(!0),this.inherited(arguments)},replaceValue:function(e){this.customUndo?this.isClosed?this.setValue(e):(this.beginEditing(),e||(e="&#160;"),this.setValue(e),this.endEditing()):this.inherited(arguments)},_setDisabledAttr:function(e){this.setValueDeferred.then(s.hitch(this,function(){!this.disabled&&e||!this._buttonEnabledPlugins&&e?a.forEach(this._plugins,function(e){e.set("disabled",!0)}):this.disabled&&!e&&a.forEach(this._plugins,function(e){e.set("disabled",!1)})})),this.inherited(arguments)},_setStateClass:function(){try{this.inherited(arguments),this.document&&this.document.body&&(n.set(this.document.body,"color",n.get(this.iframe,"color")),n.set(this.document.body,"background-color",n.get(this.iframe,"background-color")))}catch(e){}}});return s.mixin(p.registry,{undo:E,redo:E,cut:E,copy:E,paste:E,insertOrderedList:E,insertUnorderedList:E,indent:E,outdent:E,justifyCenter:E,justifyFull:E,justifyLeft:E,justifyRight:E,"delete":E,selectAll:E,removeFormat:E,unlink:E,insertHorizontalRule:E,bold:G,italic:G,underline:G,strikethrough:G,subscript:G,superscript:G,"|":function(){return new p({setEditor:function(e){this.editor=e,this.button=new h({ownerDocument:e.ownerDocument})}})}}),j});//# sourceMappingURL=Editor.js.map